<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { SolutionsResourceCards } from '~/components/solutions/index.vue';
import {
  CodeSuggestionsSalesFormWrapper,
  CodeSuggestionsSalesHero,
} from '~/components/solutions/code-suggestions/sales/index.vue';

export default Vue.extend({
  name: 'SmallBusinessPromotion',
  components: {
    CodeSuggestionsSalesFormWrapper,
    CodeSuggestionsSalesHero,
    SolutionsResourceCards,
  },
  async asyncData({ $content, i18n }) {
    const currentLocale = i18n.locale;
    const content = await $content(`${currentLocale}/pricing/smb-promo`)
      .fetch()
      .catch((error) => new Error(error));
    return { content, currentLocale };
  },
  data() {
    return {
      submitted: false,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      this.content.seo,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  methods: {
    onFormSubmit() {
      this.$nuxt.$emit('submit');
      this.submitted = true;
      this.$router.push('#submitted-message');

      if (this.$refs.targetRef) {
        this.$refs.targetRef.style.scrollMarginTop = '200px';
        this.$refs.targetRef.scrollIntoView({ behavior: 'smooth' });
      }
    },
  },
});
</script>
<template>
  <div ref="targetRef">
    <SlpContainer
      v-if="!submitted"
      key="hero"
      class="slp-pt-64 slp-pb-24 slp-py-md-64"
      variant="light-purple-100"
    >
      <SlpRow>
        <SlpColumn :cols="10">
          <SlpTypography class="slp-pb-16" tag="h2" variant="heading5-bold">
            {{ content.hero.subtitle }}
          </SlpTypography>
          <div
            class="slp-pb-16 small-business-promotion__title"
            v-html="$md.render(content.hero.title)"
          />
          <SlpTypography tag="p" variant="heading5">
            {{ content.hero.description }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <SlpContainer
      v-if="!submitted"
      key="body"
      variant="light-purple-100"
      class="slp-pb-48"
    >
      <SlpRow>
        <SlpColumn :cols="6">
          <SlpRow>
            <SlpColumn :cols="10">
              <div
                class="small-business-promotion__text"
                v-html="$md.render(content.markdown)"
              />
              <SlpButton
                variant="tertiary"
                :href="content.button.href"
                :data-ga-name="content.button.data_ga_name"
                :data-ga-location="content.button.data_ga_name"
              >
                {{ content.button.text }}
                <SlpIcon variant="product" name="chevron-right" />
              </SlpButton>
              <div
                v-if="content.markdown_duo"
                class="small-business-promotion__text"
                v-html="$md.render(content.markdown_duo)"
              />
              <SlpButton
                v-if="content.button_duo"
                variant="tertiary"
                :href="content.button_duo.href"
                :data-ga-name="content.button_duo.data_ga_name"
                :data-ga-location="content.button_duo.data_ga_name"
              >
                {{ content.button_duo.text }}
                <SlpIcon variant="product" name="chevron-right" />
              </SlpButton>
              <div
                class="small-business-promotion__text slp-mt-16"
                v-html="$md.render(content.promo)"
              />
            </SlpColumn>
          </SlpRow>
        </SlpColumn>
        <SlpColumn :cols="6">
          <SlpColumn :cols="11">
            <CodeSuggestionsSalesFormWrapper
              :data="content.form"
              @submit="onFormSubmit"
            >
              <div>
                <SlpTypography variant="heading3-bold">
                  <span style="color: #74717a">
                    <span style="font-size: 16px; vertical-align: super">
                      $
                    </span>
                    <span
                      style="
                        color: rgba(116, 113, 122, 0.5);
                        text-decoration: line-through;
                        text-decoration-thickness: 2px;
                      "
                    >
                      <span style="color: #74717a">48</span>
                    </span>
                  </span>
                  <span style="font-size: 16px; vertical-align: super">
                    $
                  </span>
                  19
                </SlpTypography>
                <SlpTypography
                  variant="heading5-bold"
                  style="vertical-align: super"
                >
                  {{ content.form.title }}
                </SlpTypography>
              </div>
            </CodeSuggestionsSalesFormWrapper>
          </SlpColumn>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <CodeSuggestionsSalesHero
      v-if="submitted"
      key="submitted"
      :data="content.submitted"
      :dark-background="false"
    />
    <SolutionsResourceCards
      v-if="submitted"
      key="resources"
      :data="content.resource_cards"
    />
  </div>
</template>

<style lang="scss">
.code-suggestions-sales-hero__thank-you-note {
  margin: 0;
  padding: 192px 0 204px;
}
</style>

<style lang="scss" scoped>
.small-business-promotion {
  &__title {
    font-size: 64px;
    font-weight: 600;
    letter-spacing: -2.1px;
    line-height: 72px;

    @media (max-width: $breakpoint-md) {
      font-size: 48px;
      line-height: 52px;
      letter-spacing: -2.3px;
    }
  }

  &__text {
    &:deep(h3) {
      font-size: 24px;
      line-height: 32px;
      font-weight: 600;
      letter-spacing: -0.6px;

      @media (max-width: $breakpoint-md) {
        font-size: 18px;
        line-height: 28px;
        font-weight: 400;
      }
    }

    &:deep .pill {
      padding: $spacing-4 $spacing-16;
      border-radius: 100px;
      background-color: $color-surface-950;
      margin-right: $spacing-4;
      display: inline-block;
      color: $color-text-300;
    }

    &:deep(p) {
      margin: $spacing-16 0 0 0;
      strong {
        font-weight: 600;
      }
    }
    &:deep(ul) {
      padding-left: 32px;
      margin: $spacing-16 0;

      li {
        margin-top: $spacing-8;
        position: relative;

        &:before {
          content: url('/nuxt-images/icons/list-check-dark.svg');
          position: absolute;
          top: 3px;
          left: -30px;
        }
      }
    }
    &:deep(em) {
      color: $color-surface-500;
      font-size: 14px;
    }
    &:deep(a) {
      font-size: 14px;
      font-style: italic;
    }
  }
}

.code-suggestions-sales {
  overflow: hidden;
}
.content-move, /* apply transition to moving elements */
.content-enter-active,
.content-leave-active {
  transition: all 0.5s ease;
}

.content-enter-from,
.content-leave-to {
  opacity: 0;
}
.content-leave-to {
  transform: translateY(100%);
}
/* ensure leaving items are taken out of layout flow so that moving
   animations can be calculated correctly. */
.content-leave-active {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
}
</style>
